$!-----------------------------------------------------------------'f$verify(0)
$! SCRIPTS.COM
$!
$! Selectively installs or removes groups of WASD package scripts.
$! P1 can be "INSTALL" or "REMOVE" to install or remove ALL scripts.
$!
$! 30-APR-2005  MGD  bugfix; not copying CGIPLUSPROC.COM
$! 30-OCT-2004  MGD  add FORMWORK example
$! 23-DEC-2003  MGD  add CGILIB_EXAMPLE.EXE
$! 22-DEC-2002  MGD  server utility scripts
$! 01-NOV-2002  MGD  initial
$!-----------------------------------------------------------------------------
$!
$ if f$trnlnm("INSTALL$DBUG") .nes. "" then set verify
$ ss$_abort = 44
$ ss$_bugcheck = 676
$ arch_name = f$edit(f$getsyi("arch_name"),"upcase")
$ if arch_name .eqs. "ALPHA" then arch_name = "AXP"
$ say = "write sys$output"
$ vms_version = f$integer(f$extract(1,1,f$getsyi("version"))) * 10 +-
                f$integer(f$extract(3,1,f$getsyi("version")))
$ if vms_version .ge. 72 then set process /parse=traditional
$ set control=Y
$ on controly then exit ss$_abort
$!
$ install = 0
$ if p1 .eqs. "install" then install = 1
$ remove = 0
$ if p1 .eqs. "remove" then remove = 1
$ all = 0
$ if install .or. remove then all = 1
$!
$ if f$environment("depth") .eq. 1
$ then
$    type sys$input

     WASD VMS Hypertext Services, Copyright (C) 1996-2004 Mark G.Daniel.
 This package (all associated programs), comes with ABSOLUTELY NO WARRANTY.
     This is free software, and you are welcome to redistribute it under
        the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.

$ endif
$!
$ type sys$input
                        *****************************
                        *  INSTALL PACKAGE SCRIPTS  *
                        *****************************

This procedure copies scripts from the package delivery or build locations into
the directories where the server scripting account can access them.  It will
also optionally remove them again.

It is considered more secure to make available to the server only those scripts
that a site will actually use.  Others do not need to be accessable.  This
procedure allows some scripts to be selected and others not.  All groups of
scripts may be individually accepted or declined.  This procedure may be
executed any number of times to tailor the local scripting environment.

Of course, individual or groups of scripts can manually be installed by copying
the required file(s) into the required directory(ies), and manually deinstalled
by deleting them.  Most scripts describe their requirements in the source code.

$ response =  "YES"
$ read sys$command response /prompt="Continue with this procedure? [YES]: "
$ say ""
$ if response .eqs. "" then response =  "YES"
$ if .not. response then exit
$!
$ existing_scripts = 0
$ if f$search("ht_root:[cgi-bin]*.com") .nes. "" then existing_scripts = 1
$ if f$search("ht_root:['arch_name'-bin]*.exe") .nes. "" then existing_scripts = 1
$ if existing_scripts
$ then
$ type sys$input
                       *******************************
                       *  EXISTING SCRIPTS DETECTED  *
                       *******************************

$ say "Files have been detected in [CGI-BIN] or [''arch_name'-BIN]."
$ type sys$input

These can all be deleted before commencing any further script installation. 
The advantage with this is you get a very "clean" script environment.  The
DISADVANTAGE (AND IT MAY BE A SIGNIFICANT ONE) is you lose any local scripts
you have not archived elsewhere and any customization to currently installed
scripts.

$    response =  "NO"
$    read sys$command response /prompt="Delete files from these directories? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$!
$    if response .or. remove
$    then
$       delete = "delete/log"
$       delete ht_root:[cgi-bin]*.*;* /exclude=(.*;*,readme.*;*) 
$       delete ht_root:['arch_name'-bin]*.*;* /exclude=(.*;*,readme.*;*) 
$       say ""
$    endif
$!
$ endif
$!
$ if arch_name .nes. "VAX"
$ then
$    type sys$input
                         ***************************
                         *  CGILIB SHARABLE IMAGE  *
                         ***************************

CGILIBSHR32 ... CGILIB in a sharable image

STARTUP.COM will detect the presence of this image and define the system-level
logical name WASD_CGILIBSHR32 that should be linked against.

(Not available for VAX where build dependencies are too proscriptive.)

$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Install this image? [NO]: "
$    if response .eqs. "" then response =  "NO"
$    if response .or. install
$    then
$       say ""
$       copy = "copy/log"
$       set noon
$    copy ht_root:['arch_name']cgilibshr32.exe ht_root:['arch_name'-bin]
$    set on
$    say ""
$    else
$       response =  "NO"
$       if .not. all then read sys$command response /prompt="Remove this image (if installed)? [NO]: "
$       say ""
$       if response .eqs. "" then response =  "NO"
$       if response .or. remove
$       then
$          delete = "delete/log"
$          set noon
$          delete ht_root:['arch_name'-bin]cgilibshr32.exe;*
$          set on
$          say ""
$       endif
$    endif
$ endif
$!
$ type sys$input
                        ****************************
                        *  SERVER UTILITY SCRIPTS  *
                        ****************************

PCACHE.EXE ......... proxy cache reporting and maintainance script
QDLOGSTATS.EXE ..... Quick and Dirty LOG STATisticS

$ response =  "NO"
$ if .not. all then read sys$command response /prompt="Install these scripts? [NO]: "
$ if response .eqs. "" then response =  "NO"
$ if response .or. install
$ then
$    say ""
$    copy = "copy/log"
$    set noon
$    copy ht_root:['arch_name']pcache.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']qdlogstats.exe ht_root:['arch_name'-bin]
$    set on
$    say ""
$ else
$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Remove these scripts (if installed)? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$    if response .or. remove
$    then
$       delete = "delete/log"
$       set noon
$       delete ht_root:['arch_name'-bin]pcache.exe;*
$       delete ht_root:['arch_name'-bin]qdlogstats.exe;*
$       set on
$       say ""
$    endif
$ endif
$!
$ type sys$input
                          ************************
                          *  USEFUL VMS SCRIPTS  *
                          ************************

Conan The Librarian ..... Help and Text Library access
HyperReader ............. Online Documentation, Bookreader and BNU access
HyperSPI ................ System Performance Information
hyperDISK ............... graphical disk usage report
SHOW ...................  provides system information (must be enabled)

$ response =  "NO"
$ if .not. all then read sys$command response /prompt="Install these scripts? [NO]: "
$ if response .eqs. "" then response =  "NO"
$ if response .or. install
$ then
$    say ""
$    copy = "copy/log"
$    set noon
$    copy ht_root:[script]conan.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']conan.exe ht_root:['arch_name'-bin]
$    copy ht_root:[script]hypershelf.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']hypershelf.exe ht_root:['arch_name'-bin]
$    copy ht_root:[script]hyperreader.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']hyperreader.exe ht_root:['arch_name'-bin]
$    copy ht_root:[script]hyperspi.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']hyperspi.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']hdisk.exe ht_root:['arch_name'-bin]
$    copy ht_root:[script]show.com ht_root:[cgi-bin]
$    set on
$    say ""
$ else
$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Remove these scripts (if installed)? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$    if response .or. remove
$    then
$       delete = "delete/log"
$       set noon
$       delete ht_root:[cgi-bin]conan.com;*
$       delete ht_root:['arch_name'-bin]conan.exe;*
$       delete ht_root:[cgi-bin]hypershelf.com;*
$       delete ht_root:['arch_name'-bin]hypershelf.exe;*
$       delete ht_root:[cgi-bin]hyperreader.com;*
$       delete ht_root:['arch_name'-bin]hyperreader.exe;*
$       delete ht_root:[cgi-bin]hyperspi.com;*
$       delete ht_root:['arch_name'-bin]hyperspi.exe;*
$       delete ht_root:['arch_name'-bin]hdisk.exe;*
$       delete ht_root:[cgi-bin]show.com;*
$       set on
$       say ""
$    endif
$ endif
$!
$ type sys$input
                        *****************************
                        *  DOCUMENT/FILE SEARCHING  *
                        *****************************

QUERY and EXTRACT are scripts that can be used to perform ad hoc searching of
HTML and plain-text documents and files, returning all or partial documents.
The scope of where they can search should be carefully controlled but they can
be very useful.  Check script source descriptive prologue for more detail.

$ response =  "NO"
$ if .not. all then read sys$command response /prompt="Install these scripts? [NO]: "
$ if response .eqs. "" then response =  "NO"
$ if response .or. install
$ then
$    say ""
$    copy = "copy/log"
$    set noon
$    copy ht_root:[script]query.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']query.exe ht_root:['arch_name'-bin]
$    copy ht_root:[script]extract.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']extract.exe ht_root:['arch_name'-bin]
$    set on
$    say ""
$ else
$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Remove these scripts (if installed)? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$    if response .or. remove
$    then
$       delete = "delete/log"
$       set noon
$       delete ht_root:[cgi-bin]query.com;*
$       delete ht_root:['arch_name'-bin]query.exe;*
$       delete ht_root:[cgi-bin]extract.com;*
$       delete ht_root:['arch_name'-bin]extract.exe;*
$       set on
$       say ""
$    endif
$ endif
$!
$ type sys$input
                   ***************************************
                   *  CGIPLUS/RTE DEMONSTRATION SCRIPTS  *
                   ***************************************

The CGIplus demonstration scripts are examples of how to create persistent
scripting using DCL and the C language.  See the "Scripting Overview" document
for further information on CGIplus.

Includes the CGIsapi (ISAPI) environment and demonstration DLL.

Includes the RTE (Run Time Environment) example interpreter.

$ response =  "NO"
$ if .not. all then read sys$command response /prompt="Install these scripts? [NO]: "
$ if response .eqs. "" then response =  "NO"
$ if response .or. install
$ then
$    say ""
$    copy = "copy/log"
$    set noon
$    copy ht_root:[script]cgiplusproc.com ht_root:[cgi-bin]
$    copy ht_root:[script]cgicalloutproc.com ht_root:[cgi-bin]
$    copy ht_root:[script]cgicalloutsinglebyte.com ht_root:[cgi-bin]
$    copy ht_root:[script]cgipluscalloutproc.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']cgicallout.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']cgipluscallout.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']cgiplusdemo.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']cgiplusloop.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']cgiplusskel.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']cgiplustest.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']cgisapi.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']isapiexample.dll ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']rte_example.exe ht_root:['arch_name'-bin] 
$    copy ht_root:['arch_name']cgilib_example.exe ht_root:['arch_name'-bin]
$    set on
$    say ""
$ else
$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Remove these scripts (if installed)? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$    if response .or. remove
$    then
$       delete = "delete/log"
$       set noon
$       delete ht_root:[cgi-bin]cgicalloutproc.com;*
$       delete ht_root:[cgi-bin]cgicalloutsinglebyte.com;*
$       delete ht_root:[cgi-bin]cgipluscalloutproc.com;*
$       delete ht_root:['arch_name'-bin]cgicallout.exe;*
$       delete ht_root:['arch_name'-bin]cgipluscallout.exe;*
$       delete ht_root:['arch_name'-bin]cgiplusdemo.exe;*
$       delete ht_root:['arch_name'-bin]cgiplusloop.exe;*
$       delete ht_root:['arch_name'-bin]cgiplusskel.exe;*
$       delete ht_root:['arch_name'-bin]cgiplustest.exe;*
$       delete ht_root:['arch_name'-bin]cgisapi.exe;*
$       delete ht_root:['arch_name'-bin]isapiexample.dll;*
$       delete ht_root:['arch_name'-bin]rte_example.exe;*
$       delete ht_root:['arch_name'-bin]cgilib_example.exe;*
$       set on
$       say ""
$    endif
$ endif
$!
$ type sys$input
                       *******************************
                       *  DCL DEMONSTRATION SCRIPTS  *
                       *******************************

The DCL demonstration scripts are examples of CGI scripting using DCL.

CGI_SYMBOLS.COM ....... displays the CGI variables available to a script
CGIUTL.EXE ............ utility for assisting with DCL scripts
COOKIE_DEMO.COM ....... an example of cookie manipulation using DCL.
FORMWORK.EXE .......... HTML form data validation and CSV processor
TMAILER.EXE ........... email using a template

Some include using the CGIUTL utility within the DCL environment.

$ response =  "NO"
$ if .not. all then read sys$command response /prompt="Install these scripts? [NO]: "
$ if response .eqs. "" then response =  "NO"
$ if response .or. install
$ then
$    say ""
$    copy = "copy/log"
$    set noon
$    copy ht_root:[src.other]cookie_demo.com ht_root:[cgi-bin]
$    copy ht_root:[src.other]cgi_symbols.com ht_root:[cgi-bin]
$    copy ht_root:[script]cgiutl*.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']cgiutl.exe ht_root:['arch_name'-bin]
$    copy ht_root:[script]face2face.com ht_root:[cgi-bin]
$    copy ht_root:[script]formwork_example.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']formwork.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']tmailer.exe ht_root:['arch_name'-bin]
$    set on
$    say ""
$ else
$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Remove these scripts (if installed)? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$    if response .or. remove
$    then
$       delete = "delete/log"
$       set noon
$       delete ht_root:[cgi-bin]cookie_demo.com;*
$       delete ht_root:[cgi-bin]cgi_symbols.com;*
$       delete ht_root:[cgi-bin]cgiutl*.com;*
$       delete ht_root:['arch_name'-bin]cgiutl.exe;*
$       delete ht_root:[cgi-bin]face2face.com;*
$       delete ht_root:[cgi-bin]formwork_example.com;*
$       delete ht_root:['arch_name'-bin]formwork.exe;*
$       delete ht_root:['arch_name'-bin]tmailer.exe;*
$       set on
$       say ""
$    endif
$ endif
$!
$ type sys$input
                         ***************************
                         *  MISCELLANEOUS SCRIPTS  *
                         ***************************

Calendar ........ simple calendar maker
Charset ......... displays the browser character set
Colors .......... displays fonts with different fore/background colors
Fetch ........... can get pages and other resources from HTTP servers
gList ........... list and display graphics in a directory

$ response =  "NO"
$ if .not. all then read sys$command response /prompt="Install these scripts? [NO]: "
$ if response .eqs. "" then response =  "NO"
$ if response .or. install
$ then
$    say ""
$    copy = "copy/log"
$    set noon
$    copy ht_root:['arch_name']calendar.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']charset.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']colors.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']fetch.exe ht_root:['arch_name'-bin]
$    copy ht_root:[script]fetch_example.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']glist.exe ht_root:['arch_name'-bin]
$    set on
$    say ""
$ else
$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Remove these scripts (if installed)? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$    if response .or. remove
$    then
$       delete = "delete/log"
$       set noon
$       delete ht_root:['arch_name'-bin]calendar.exe;*
$       delete ht_root:['arch_name'-bin]charset.exe;*
$       delete ht_root:['arch_name'-bin]colors.exe;*
$       delete ht_root:['arch_name'-bin]fetch.exe;*
$       delete ht_root:[cgi-bin]fetch_example.com;*
$       delete ht_root:['arch_name'-bin]glist.exe;*
$       set on
$       say ""
$    endif
$ endif
$!
$ type sys$input
                   **************************************
                   *  OSU/DECNET DEMONSTRATION SCRIPTS  *
                   **************************************

These are some OSU demonstration scripts (from the OSU package).
There are also WASD-specific CGI DECnet script examples.

$ response =  "NO"
$ if .not. all then read sys$command response /prompt="Install these scripts? [NO]: "
$ if response .eqs. "" then response =  "NO"
$ if response .or. install
$ then
$    say ""
$    copy = "copy/log"
$    set noon
$    copy ht_root:['arch_name']cgi_symbols.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']html_preproc.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']html_preproc.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']set_dcl_env.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']dcl_env_rm.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']osu_testcgi.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']osu_testform.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']tmail.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']vmshelpgate.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']helpgate.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']webbook.exe ht_root:['arch_name'-bin]
$    copy ht_root:['arch_name']cgiwasd.com ht_root:[cgi-bin]
$    copy ht_root:['arch_name']wwwexec.com ht_root:[cgi-bin]
$    set on
$    say ""
$ else
$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Remove these scripts (if installed)? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$    if response .or. remove
$    then
$       delete = "delete/log"
$       set noon
$       delete ht_root:['arch_name'-bin]cgi_symbols.exe;*
$       delete ht_root:['arch_name'-bin]html_preproc.exe;*
$       delete ht_root:[cgi-bin]html_preproc.com;*
$       delete ht_root:['arch_name'-bin]set_dcl_env.exe;*
$       delete ht_root:[cgi-bin]dcl_env_rm.com;*
$       delete ht_root:['arch_name'-bin]osu_testcgi.exe;*
$       delete ht_root:['arch_name'-bin]osu_testform.exe;*
$       delete ht_root:['arch_name'-bin]tmail.exe;*
$       delete ht_root:['arch_name'-bin]vmshelpgate.exe;*
$       delete ht_root:[cgi-bin]helpgate.com;*
$       delete ht_root:['arch_name'-bin]webbook.exe;*
$       delete ht_root:[cgi-bin]cgiwasd.com;*
$       delete ht_root:[cgi-bin]wwwexec.com;*
$       set on
$       say ""
$    endif
$ endif
$!
$ type sys$input
                      ********************************
                      *  JAVA DEMONSTRATION CLASSES  *
                      ********************************

The JAVA.COM java script wrapper procedure and example Java classes.

$ response =  "NO"
$ if .not. all then read sys$command response /prompt="Install these scripts? [NO]: "
$ if response .eqs. "" then response =  "NO"
$ if response .or. install
$ then
$    say ""
$    copy = "copy/log"
$    set noon
$    copy ht_root:[script]java.com ht_root:[cgi-bin]
$    copy ht_root:[script]cgiplus.class ht_root:[cgi-bin]
$    copy ht_root:[script]dumpcgi.class ht_root:[cgi-bin]
$    copy ht_root:[script]hi1cgi.class ht_root:[cgi-bin]
$    copy ht_root:[script]hi1cgiplus.class ht_root:[cgi-bin]
$    copy ht_root:[script]hi2cgi.class ht_root:[cgi-bin]
$    copy ht_root:[script]hi2cgiplus.class ht_root:[cgi-bin]
$    copy ht_root:[script]postcgi.class ht_root:[cgi-bin]
$    copy ht_root:[script]postcgiplus.class ht_root:[cgi-bin]
$    set on
$    say ""
$ else
$    response =  "NO"
$    if .not. all then read sys$command response /prompt="Remove these scripts (if installed)? [NO]: "
$    say ""
$    if response .eqs. "" then response =  "NO"
$    if response .or. remove
$    then
$       delete = "delete/log"
$       set noon
$       delete ht_root:[cgi-bin]java.com;*
$       delete ht_root:[cgi-bin]cgiplus.class;*
$       delete ht_root:[cgi-bin]dumpcgi.class;*
$       delete ht_root:[cgi-bin]hi1cgi.class;*
$       delete ht_root:[cgi-bin]hi1cgiplus.class;*
$       delete ht_root:[cgi-bin]hi2cgi.class;*
$       delete ht_root:[cgi-bin]hi2cgiplus.class;*
$       delete ht_root:[cgi-bin]postcgi.class;*
$       delete ht_root:[cgi-bin]postcgiplus.class;*
$       set on
$       say ""
$    endif
$ endif
$!
$ type sys$input
                      ********************************
                      *  [LOCAL]INSTALL_SCRIPTS.COM  *
                      ********************************

This convenience procedure may be created and maintained by local site
administration with DCL commands to ensure that required local site scripts are
correctly set up and/or configured for correct operation following an update or
reapplication of site security.

$ if f$search("ht_root:[local]install_scripts.com") .eqs. ""
$ then
$    type sys$input
This procedure was NOT FOUND on this site!

$ else
$    response =  "YES"
$    if .not. all then read sys$command response /prompt="Execute this procedure? [YES]: "
$    if response .eqs. "" then response =  "YES"
$    if response
$    then
$       set noon
$       @HT_ROOT:[LOCAL]INSTALL_SCRIPTS.COM
$       set on
$    endif
$ endif
$!
$ type sys$input
                   ***************************************
                   *  INSTALL SCRIPTS   C O M P L E T E  *
                   ***************************************

$ exit
$!-----------------------------------------------------------------------------
