/*****************************************************************************/
/*
                                 Error.h
*/
/*****************************************************************************/

#ifndef ERROR_H_LOADED
#define ERROR_H_LOADED 1

#include "wasd.h"

#define ERROR_REPORT_BASIC     1
#define ERROR_REPORT_DETAILED  2
#define ERROR_REPORT_TUNNEL       3

#define ERROR_REPORTED(rqptr) (rqptr->rqResponse.ErrorReportPtr)
#define ERROR_REPORTED_BY_SCRIPT(rqptr) (rqptr->rqCgi.ScriptControlErrorTextPtr)

/***********************/
/* function prototypes */
/***********************/

ErrorHeapAlloc (REQUEST_STRUCT*, char*, int);
ErrorExitVmsStatus (int, char*, char*, int);
ErrorGeneral (REQUEST_STRUCT*, char*, ...);
ErrorGeneralOverflow (REQUEST_STRUCT*, char*, int);
ErrorInternal (REQUEST_STRUCT*, int, char*, char*, int);
ErrorMessageDividerAst (REQUEST_STRUCT*);
ErrorNoticed (REQUEST_STRUCT*, int, char*, char*, int);
#define ReportSuccess ErrorReportSuccess
ErrorRedirectQueryString (REQUEST_STRUCT*, int, char*, char*, char*, int);
ErrorReportSuccess (REQUEST_STRUCT*, char*, ...);
ErrorReportHeader (REQUEST_STRUCT*, unsigned long**);
ErrorReportEndHeader (REQUEST_STRUCT*, unsigned long**);
ErrorReportFooter (REQUEST_STRUCT*, unsigned long**);
ErrorSendToClient (REQUEST_STRUCT*);
ErrorServerShutdown (unsigned short);
char* ErrorSourceInfo (char*, int);
ErrorVmsStatus (REQUEST_STRUCT*, int, char*, int);

#endif /* ERROR_H_LOADED */

/*****************************************************************************/

